## minexpert3 10.0.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

project(
    MineXpert3
    VERSION 10.0.0
    DESCRIPTION "A program to visualize and explore mass spectrometric data"
    HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert3"
)

set(LOWCASE_PROJECT_NAME minexpert3)

set(TARGET ${PROJECT_NAME})

# project(VERSION) above sets: PROJECT_VERSION, <PROJECT-NAME>_VERSION
# PROJECT_VERSION_MAJOR, <PROJECT-NAME>_VERSION_MAJOR PROJECT_VERSION_MINOR,
# <PROJECT-NAME>_VERSION_MINOR PROJECT_VERSION_PATCH,
# <PROJECT-NAME>_VERSION_PATCH

# Set additional project information
set(COMPANY "MsXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2016-2025 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


#############################################################
#############################################################
# Installation prefix (these lines before include(GNUInstallDirs))
if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX /usr/local)
endif()

include(GNUInstallDirs)

message(STATUS: CMAKE_CXX_LIBRARY_ARCHITECTURE is: ${CMAKE_CXX_LIBRARY_ARCHITECTURE})

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# Our build scripts take for granted that this files is available.
configure_file(${CMAKE_UTILS_PATH}/version.cmake.in ${CMAKE_BINARY_DIR}/version.txt)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldGreen}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin) and by the Clang-based code analyzer.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json")
    execute_process(
        COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
                ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()

# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "Setting definition -Wall -pedantic.")
add_definitions(-Wall -pedantic)
message(STATUS "Setting definition -Wextra.")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
    message(STATUS "Setting definition -Werror.")
    add_definitions(-Werror)
endif()

message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")

option(MXE "Use the cross-compiling environment MXE" OFF)

option(PAPPSO_LOCAL_DEV "Use locally developped libpappsomspp" OFF)
option(PAPPSO_LOCAL_INST "Use /usr/local/lib installed libpappsomspp" OFF)

if(PAPPSO_LOCAL_DEV AND PAPPSO_LOCAL_INST)
message(FATAL_ERROR "Cannot have both PAPPSO_LOCAL_DEV and PAPPSO_LOCAL_INST")
endif()

message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")
message(STATUS "PAPPSO_LOCAL_INST: ${PAPPSO_LOCAL_INST}")

option(XPERTMASS_LOCAL_DEV "Use locally developped libXpertMass" OFF)
option(XPERTMASS_LOCAL_INST "Use /usr/local/lib installed libXpertMass" OFF)

if(XPERTMASS_LOCAL_DEV AND XPERTMASS_LOCAL_INST)
message(FATAL_ERROR "Cannot have both XPERTMASS_LOCAL_DEV and XPERTMASS_LOCAL_INST")
endif()

message(STATUS "XPERTMASS_LOCAL_DEV: ${XPERTMASS_LOCAL_DEV}")
message(STATUS "XPERTMASS_LOCAL_INST: ${XPERTMASS_LOCAL_INST}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

    if(MXE)

        # Run the following cmake command line:
        # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
        include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

        # Set the name to the systemUname variable because in this situation that name
        # is not found, it it passed as a flag in the command line.
        set(SYSTEM_UNAME_S "mxe")

    elseif(WIN10MINGW64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
    endif()

elseif(UNIX)

    message("UNIX toolchain being selected")

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)

endif()

# Define this as On if JavaScript/Qml bindings are to be exported.
# See src/CMakeLists.txt
# See #cmakedefine in CMakeStuff/config.h.cmake.in
# Need to #inlude "config.h" for the defined value to be visible.
# option(JS_QML "Generate the JavaScript/Qml bindings plugin lib" Off)


message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")

#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE
        Release
        CACHE STRING "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel." FORCE
    )
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    message(STATUS "Compiling in release with debug info mode.")
endif()

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

if(PROFILE)
    message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
    add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
    execute_process(
        COMMAND inkscape ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg -o ${CMAKE_SOURCE_DIR}/images/splashscreen.png
                -w 600
    )
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)


#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
option(BUILD_USER_MANUAL "Build the user manual, on UNIX only." OFF)
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)

# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_UTILS_PATH}/config.h.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "PROJECT_INSTALL_BIN_DIR: ${PROJECT_INSTALL_BIN_DIR}")
message(STATUS "PROJECT_INSTALL_LIB_DIR: ${PROJECT_INSTALL_LIB_DIR}")
message(STATUS "PROJECT_INSTALL_LIB_QML_DIR: ${PROJECT_INSTALL_LIB_QML_DIR}")
message(STATUS "PROJECT_INSTALL_DATA_DIR: ${PROJECT_INSTALL_DATA_DIR}")
message(STATUS "PROJECT_INSTALL_DOC_DIR: ${PROJECT_INSTALL_DOC_DIR}")

#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(
    archive
    cpack
    -G
    TGZ
    --config
    CPackSourceConfig.cmake
    &&
    mv
    ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    &&
    ln
    -sf
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${PROJECT_VERSION}.tar.gz
    ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${PROJECT_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz"
    VERBATIM
)

#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}Installation BIN directory: ${PROJECT_INSTALL_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation LIB directory: ${PROJECT_INSTALL_LIB_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation LIB QML directory: ${PROJECT_INSTALL_LIB_QML_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation DATA directory: ${PROJECT_INSTALL_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}Installation DOC directory: ${PROJECT_INSTALL_DOC_DIR}${ColourReset}")

if(PROFILE)
    message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
    message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
    message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
    message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
    message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(
    STATUS

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man minexpert3.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/minexpert3.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif()


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${PROJECT_INSTALL_DOC_DIR}")
install(FILES history.html ../LICENSE
	DESTINATION ${PROJECT_INSTALL_DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
	add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message("\n${BoldRed}Now configuring src/js_qml for ${TARGET}${ColourReset}\n")

set(NONGUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/nongui)
set(GUI_DIR ${CMAKE_CURRENT_SOURCE_DIR}/gui)

########################################################
# Files
set(${TARGET}_nongui_SRCS
    #
    # The classes that handle the processing flow
    ${NONGUI_DIR}/ProcessingFlow.cpp
    ${NONGUI_DIR}/ProcessingStep.cpp
    ${NONGUI_DIR}/ProcessingType.cpp
    #
    # Some globals.
    ${NONGUI_DIR}/globals.cpp
    #
    # The classes to look into an MS run prior to loading it
    ${NONGUI_DIR}/MsRunProber.cpp
    ${NONGUI_DIR}/vendor/BrukerTimsTofMsRunProber.cpp
    #
    # The main class that hold the mass data.
    ${NONGUI_DIR}/MsRunDataSet.cpp
    #
    # The class to handle the statistics computation about a given MsRunDataSet.
    ${NONGUI_DIR}/MsRunDataSetStats.cpp
    #
    # The class to load MS run data
    ${NONGUI_DIR}/MassSpecDataFileLoader.cpp
    ${NONGUI_DIR}/MassSpecDataFileLoaderToVector.cpp
    #
    # The base class of the integrators.
    ${NONGUI_DIR}/MassDataIntegrator.cpp
    #
    # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
    ${NONGUI_DIR}/MsRunDataSetTreeMassDataIntegratorToRt.cpp
    #
    # The classe that monitors integrators.
    ${NONGUI_DIR}/MassDataIntegratorTask.cpp
    #
    # The various MsRunDataSetTreeNodeVisitor classes.
    ${NONGUI_DIR}/BaseMsRunDataSetTreeNodeVisitor.cpp
    ${NONGUI_DIR}/MsRunStatisticsTreeNodeVisitor.cpp
    ${NONGUI_DIR}/MultiTreeNodeCombinerVisitor.cpp
    ${NONGUI_DIR}/TicChromTreeNodeCombinerVisitor.cpp
    ${NONGUI_DIR}/TicChromatogramFromMassSpecDataFile.cpp
    # #
    # # The various integrators that use QualifiedMassSpectrumVector.
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
    ${NONGUI_DIR}/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
    # #
    # # The classes that handle the parameters for the various integrations and the
    # # display of traces.
    ${NONGUI_DIR}/MsFragmentationSpec.cpp
    # #
    # # Analysis preferences
    ${NONGUI_DIR}/AnalysisPreferences.cpp
)

set(${TARGET}_gui_SRCS
    #
    ${GUI_DIR}/AboutDlg.cpp
    ${GUI_DIR}/Application.cpp
    ${GUI_DIR}/ProgramWindow.cpp
    #
    ${GUI_DIR}/MsRunLoader.cpp
    ${GUI_DIR}/ConsoleWnd.cpp
    #
    ${GUI_DIR}/vendor/BrukerTimsTofMsRunLoader.cpp
    ${GUI_DIR}/vendor/BrukerBafAsciiMsRunLoader.cpp
    ${GUI_DIR}/vendor/PwizLiteMsRunLoader.cpp
    ${GUI_DIR}/XyMsRunLoader.cpp
    ${GUI_DIR}/MsRunReadTask.cpp
    ${GUI_DIR}/MsRunProbeTask.cpp
    # #
    ${GUI_DIR}/OpenMsRunDataSetsDlg.cpp
    #
    ${GUI_DIR}/TaskMonitorCompositeWidget.cpp
    ${GUI_DIR}/TaskMonitorWnd.cpp
    #
    ${GUI_DIR}/MsRunProbeInfoViewerDlg.cpp
    ${GUI_DIR}/MsRunSelectorDlg.cpp
    #
    # The ms run data set tree view classes
    ${GUI_DIR}/MsRunDataSetTableViewWnd.cpp
    ${GUI_DIR}/MsRunDataSetTableViewItem.cpp
    ${GUI_DIR}/MsRunDataSetTableView.cpp
    ${GUI_DIR}/MsRunDataSetTableViewModel.cpp
    ${GUI_DIR}/MsRunDataSetTableViewProxyModel.cpp
    #
    # The MS fragmentation specification dialog
    ${GUI_DIR}/MsFragmentationSpecDlg.cpp
    #
    # The M/Z integration parameters dialog
    ${GUI_DIR}/MzIntegrationParamsDlg.cpp
    #
    # The Savitzky-Golay filter params dialog
    ${GUI_DIR}/SavitzkyGolayFilterParamsDlg.cpp
    #
    # The data plot graph/widget tree classes
    ${GUI_DIR}/DataPlottableNode.cpp
    ${GUI_DIR}/DataPlottableTree.cpp
    #
    # The trace plot widgets derived from pappso::BaseTracePlotWidget
    ${GUI_DIR}/TicXicChromTracePlotWidget.cpp
    ${GUI_DIR}/MassSpecTracePlotWidget.cpp
    ${GUI_DIR}/DriftSpecTracePlotWidget.cpp
    #
    # The trace plot composite widgets
    ${GUI_DIR}/BasePlotCompositeWidget.cpp
    ${GUI_DIR}/BaseTracePlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromTracePlotCompositeWidget.cpp
    ${GUI_DIR}/MassSpecTracePlotCompositeWidget.cpp
    ${GUI_DIR}/DriftSpecTracePlotCompositeWidget.cpp
    #
    # The color map plot composite widgets
    ${GUI_DIR}/BaseColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
    ${GUI_DIR}/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
    #
    # The plot windows
    ${GUI_DIR}/BasePlotWnd.cpp
    #
    # Trace plot windows
    ${GUI_DIR}/BaseTracePlotWnd.cpp
    ${GUI_DIR}/BaseColorMapPlotWnd.cpp
    ${GUI_DIR}/TicXicChromTracePlotWnd.cpp
    ${GUI_DIR}/MassSpecTracePlotWnd.cpp
    ${GUI_DIR}/DriftSpecTracePlotWnd.cpp
    #
    # Color map plot windows
    ${GUI_DIR}/TicXicChromMassSpecColorMapWnd.cpp
    ${GUI_DIR}/TicXicChromDriftSpecColorMapWnd.cpp
    ${GUI_DIR}/DriftSpecMassSpecColorMapWnd.cpp
    #
    # The save plot to graphics file
    ${GUI_DIR}/SaveToGraphicsFileDlg.cpp
    #
    # The ProcessingFlow viewer dialog window
    ${GUI_DIR}/ProcessingFlowViewerDlg.cpp
    #
    # The XIC chromatogram feature
    ${GUI_DIR}/XicExtractionWnd.cpp
    #
    # Analysis preferences
    ${GUI_DIR}/AnalysisPreferencesDlg.cpp
    #
    # Labelled widget-based QAction classes
    ${GUI_DIR}/LabelledDoubleSpinBoxAction.cpp
    ${GUI_DIR}/LabelledNumberLineEditAction.cpp
    #
    # Plot overlay transparent widget
    ${GUI_DIR}/PlotAreaOverlay.cpp
)

set(${TARGET}_UIS
    ${GUI_DIR}/ui/AboutDlg.ui
    ${GUI_DIR}/ui/MsRunSelectorDlg.ui
    ${GUI_DIR}/ui/OpenMsRunDataSetsDlg.ui
    ${GUI_DIR}/ui/MsRunDataSetTableViewWnd.ui
    ${GUI_DIR}/ui/BasePlotWnd.ui
    ${GUI_DIR}/ui/BasePlotCompositeWidget.ui
    ${GUI_DIR}/ui/TaskMonitorCompositeWidget.ui
    ${GUI_DIR}/ui/TaskMonitorWnd.ui
    ${GUI_DIR}/ui/ConsoleWnd.ui
    ${GUI_DIR}/ui/MsFragmentationSpecDlg.ui
    ${GUI_DIR}/ui/MzIntegrationParamsDlg.ui
    ${GUI_DIR}/ui/SavitzkyGolayFilterParamsDlg.ui
    ${GUI_DIR}/ui/SaveToGraphicsFileDlg.ui
    ${GUI_DIR}/ui/ProcessingFlowViewerDlg.ui
    ${GUI_DIR}/ui/XicExtractionWnd.ui
    ${GUI_DIR}/ui/AnalysisPreferencesDlg.ui
    ${GUI_DIR}/ui/MsRunProbeInfoViewerDlg.ui
)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${GUI_DIR}/ui)

qt_standard_project_setup(REQUIRES 6.5)

qt6_add_resources(${TARGET}_qrc_CPP ../${TARGET}.qrc)

# if(JS_QML)
#
#     find_package(Qt6 REQUIRED COMPONENTS Quick)
#
#     # If we want scripting, the libPappsoMSplugin.so shared lib
#     # must be found.
#
#     #find_package(PappsoMS REQUIRED COMPONENTS PappsoMS)
#     find_package(PappsoMS REQUIRED)
#
#     if(NOT PappsoMS_FOUND)
#         message(FATAL_ERROR "PappsoMS plugin lib not found.")
#     endif()
#
#     get_target_property(PappsoMS_IMPORTED_CONFIGS PappsoMS::PappsoMS IMPORTED_CONFIGURATIONS)
#     message(STATUS "Available configurations: ${PappsoMS_IMPORTED_CONFIGS}")
#
#     get_target_property(PappsoMS_IMPORTED_LOCATION_DEBUG PappsoMS::PappsoMS IMPORTED_LOCATION_DEBUG)
#     message(STATUS "Debug PappsoMS::PappsoMS location: ${PappsoMS_IMPORTED_LOCATION_DEBUG}")
#
#     get_target_property(PappsoMS_IMPORTED_LOCATION_RELEASE PappsoMS::PappsoMS IMPORTED_LOCATION_RELEASE)
#     message(STATUS "Release PappsoMS::PappsoMS location: ${PappsoMS_IMPORTED_LOCATION_RELEASE}")
#
#     # Check current build type
#     string(TOUPPER "${CMAKE_BUILD_TYPE}" CURRENT_BUILD_TYPE_UPPER)
#     message(STATUS "Current build type: ${CURRENT_BUILD_TYPE_UPPER}")
#
#     # Like this: /usr/local/lib/qml/PappsoMS/libPappsoMSplugin.so
#     get_target_property(PappsoMS_ACTIVE_PATH PappsoMS::PappsoMS IMPORTED_LOCATION_${CURRENT_BUILD_TYPE_UPPER})
#     if(NOT PappsoMS_ACTIVE_PATH)
#         get_target_property(PappsoMS_ACTIVE_PATH PappsoMS::PappsoMS IMPORTED_LOCATION)
#     endif()
#     message(STATUS "Active library path: ${PappsoMS_ACTIVE_PATH}")
#
#     # Like this: /usr/local/lib/qml/PappsoMS
#     get_filename_component(PappsoMS_ACTIVE_DIR_PATH "${PappsoMS_ACTIVE_PATH}" DIRECTORY)
#     message(STATUS "PappsoMS_ACTIVE_DIR_PATH: ${PappsoMS_ACTIVE_DIR_PATH}")
#
#     set_property(GLOBAL PROPERTY PappsoMS_ACTIVE_DIR_PATH ${PappsoMS_ACTIVE_DIR_PATH})
#
#     get_target_property(PappsoMS_INCLUDE_DIRS PappsoMS::PappsoMS INTERFACE_INCLUDE_DIRECTORIES)
#     message(STATUS "PappsoMS_INCLUDE_DIRS: ${PappsoMS_INCLUDE_DIRS}")
#
#     # Also, add some scripting-specific stuff from this project.
#     add_subdirectory(js_qml)
#
#     set(JS_QML_DEPENDENCIES PRIVATE Qt6::Quick PappsoMS::PappsoMS ${TARGET}_qml)
#
#     qt6_add_resources(${TARGET}_qrc_CPP js_qml/${TARGET}_js_qml.qrc)
#
# endif()


###############################################################
# Configuration of the binary to be built
###############################################################

message(STATUS "CMAKE_CURRENT_SOURCE_DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

include_directories(
    # The config file is binary directory-specific !!!
    # For the config.h file generated from config.h.cmake.in
    # For the ui_Xyyyyy.h files
    ${CMAKE_CURRENT_BINARY_DIR}
    # The omp.h include directory as crafted by looking into the
    # libraries' paths after find_package(OpenMP). See CMake code
    # in the main CMakeLists.txt file.
    ${OpenMP_CXX_INCLUDE_DIRS}
    # For all the source subdirectories
    ${NONGUI_DIR}
    ${GUI_DIR}
)

if(WIN32 OR _WIN32)

    qt_add_executable(
        ${TARGET}
        WIN32
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
    )

    # In Debug mode we want the console to be opened so that we can read the debug
    # messages. But in Release mode the console is not desirable (the snippet
    # below removes it).
    if(CMAKE_BUILD_TYPE STREQUAL "Release")
        set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
    endif()

elseif(UNIX)

    qt_add_executable(
        ${TARGET}
        main.cpp
        ${${TARGET}_nongui_SRCS}
        ${${TARGET}_gui_SRCS}
        ${${TARGET}_UIS}
        ${${TARGET}_qrc_CPP}
        ${PLATFORM_SPECIFIC_SOURCES}
    )

endif()

# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at
# the end and the private libs are listed first.
target_link_libraries(
    ${TARGET}
    PRIVATE OpenMP::OpenMP_CXX
            -Wl,--no-as-needed
            XpertMass::Core
            XpertMass::Gui
            -Wl,--as-needed
            -Wl,--no-as-needed
            PappsoMSpp::Core
            PappsoMSpp::Gui
            -Wl,--as-needed
            -Wl,--no-as-needed
            IsoSpec++::IsoSpec++
            -Wl,--as-needed
            QCustomPlotQt6::QCustomPlotQt6
            QuaZip::QuaZip
            Qt6::Widgets
            Qt6::Svg
            Qt6::PrintSupport
            Qt6::Xml
            Qt6::Network
            # For pappsomspp Bruker timsTOF data handling
            Qt6::Sql
            Qt6::Concurrent
            Qt6::Qml
            # ${JS_QML_DEPENDENCIES}
)

# These options allow for printing messages to the console from
# which the program is run (for example, in Linux, with wine MineXpert3).
if(WIN32)
    target_link_options(${TARGET} PRIVATE "-Wl,--subsystem,console")
endif()

if(PROFILE)
    message(STATUS "Profiling is requested, adding linker -pg flag.")
    set(CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

=== doc/user-manual/CMakeLists.txt ===
message("\n${BoldGreen}Configuring subdirectory doc/user-manual${ColourReset}\n")

if(BUILD_USER_MANUAL)

  if(UNIX)

    message("")
    message("\n${BoldYellow}Configuring the user manual compilation${ColourReset}\n")
    message("")

    # The version of the program needs to be set in the user manual front
    # matter.
    configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.cmake.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

    # The file driving the user manual build is DC-user-manual.
    # This file contains a config bit that points to the directory
    # that contains de fop.xconf configuration file needed by
    # the FOP utility that crafts the user manual pdf file.

    set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
    configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)

    message("\tConfiguring the user manual compilation")

    # The output of Daps will be in BUILD_DIR.
    add_custom_target(user-manual
      ALL
      COMMAND make BUILD_DIR=${CMAKE_BINARY_DIR}/doc -f usermanual-makefile all_f
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc/user-manual
      COMMENT "Build of the DocBook-based user manual \
      documentation in ${CMAKE_BINARY_DIR}/doc")

    install(FILES
      ${CMAKE_BINARY_DIR}/doc/user-manual/${TARGET}-doc.pdf
      DESTINATION ${PROJECT_INSTALL_DOC_DIR})

    install(DIRECTORY
      ${CMAKE_BINARY_DIR}/doc/user-manual/html/user-manual/
      DESTINATION ${PROJECT_INSTALL_DOC_DIR}/html)

    message("")
    message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
    message("")

  else()

    message(STATUS "User manual build skipped")

  endif()

endif()

message("\n${BoldGreen}Done configuring subdirectory doc/user-manual${ColourReset}\n")

=== debian/changelog ===
minexpert3 (10.0.0-1) unstable; urgency=low

  * New version of the project ported to the new libXpertMass/libXpertMassGui
    libraries.

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 01 Jun 2025 21:30:05 +0200

minexpert2 (9.6.0-1) unstable; urgency=low

  * Big new upstream version that new relies on shared libraries
    libxpertmass and libxpertmass-gui instead of having the two
    static libraries made inside the source tree.

    Thus, now depends on libxpertmass-dev (>= 1.0.0).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 15:01:38 +0200

minexpert2 (9.5.0-1) unstable; urgency=low

  * Major bug fix and new features:
    - Fix bug in pappsomspp not reading correctly
      Bruker timsTOF data when restricting the m/z range.
    - Reworked the code about handling the MS run probing
      when loading Bruker timsTOF data files.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 31 May 2024 19:25:09 +0200

minexpert2 (9.4.1-1) unstable; urgency=low

  * Update dependency to new libpappsomspp version.
  * Added maintainer scripts to handle libmass and libmassgui code.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 May 2024 19:42:37 +0200

minexpert2 (9.4.0-1) unstable; urgency=low

  * Major work on network communications between mineXpert2 and massXpert2;
  * Now allow for the opening of Bruker BafAscii files (in full only);
  * Fixed missing proper XY mass data loading feature;
  * Really implement libmass and libmassgui source trees as git submodules;
  * Set proper color to widgets that need their parentship with a given
    sample to be clearly visible;
  * Added feature to capture on simple mouse click of the x or y axis value
    on a trace;
  * Implement a QSettings-based memory for the Savitzky-Golay filter parameters.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 May 2024 13:30:55 +0200

minexpert2 (9.3.2-1) UNRELEASED; urgency=low

  * Implemented provisions for Bruker timsTOF data that might have
    been integrated by flatteing IMS scans, thus having no
    ion mobility data anymore.

  * Implemented multi m/z XIC extractions.

  * Reworked fully the SelectionPolygon code into a new implementation named
    IntegrationScope.

  * Last fixes to the user manual build system.

  * Update dependency to libpappsomspp (version 0.9.24).

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Dec 2023 12:16:47 +0100

minexpert2 (9.3.1-1) unstable; urgency=low

  * New upstream version improving the probing of the Bruker timsTOF data
    prior to loading.

  * Documented new feature in the user manual.

  * Improved the user manual build to avoid copying the whole
    directory to the build directory.

  * libpappsomspp-dev (>= 0.9.20)

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 06 Dec 2023 13:02:17 +0100

minexpert2 (9.2.2-1) unstable; urgency=low

  * Fix bug: minexpert2: Fails to build source after successful build. Running
    dpkg-buildpackage; dpkg-buildpackage -S works flawlessly (Closes:
    #1046641). Thanks Lucas Nussbaum for reporting the bug.

  * Update dependency over libpappsomspp*.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 20 Nov 2023 18:12:24 +0100

minexpert2 (9.2.1-1) unstable; urgency=medium

  * Upstream release

    - a serious bug has been fixed (not removing mass spectra from the set to
    be integrated based on the DT range; commit
    df32744d79564f477c7f2358f7681adb5373cb59).

    - improvements to the GUI (added syntax-explanating tooltips to the mass
    spectral data table view filtering line edit widgets)

    - fixed small memory leaks

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 30 Jun 2023 10:51:55 +0200

minexpert2 (9.2.0-1) unstable; urgency=low

  * New upstream release with improvements in the way plots are exported
    as graphics files or as a clipboard object (SVG or RASTER).

  * Update dep lib version libpappsomspp-dev (>= 0.9.12).

  * Removed a bunch of dep pacakges versions.

  * Standards-Version: 4.6.2

  * Remove Conflicts: msxpertsuite-minexpert-data-doc and co.

  * Should fix the build failure (Closes: #1037777).

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 20 Jun 2023 16:56:43 +0200

minexpert2 (9.1.0-1) unstable; urgency=low

  * Version 9.0.0 was not published.
  * New upstream release with improvements.

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 13 May 2023 19:37:17 +0200

minexpert2 (8.6.3-1) unstable; urgency=low

  * New upstream with a bunch of improvements in the feedback to the user mass
    spectrometry traces-wise (reporting of the mass delta, number of decimals
    increased for super-high-resolution instruments.).

  * Depend on new version of pappsomspp libs.

  * Fix deprecation error with new Qt version (Closes: #1031104). Thanks to
    Santiago Vila <sanvila@debian.org> for reporting it.

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 12 Feb 2023 11:14:24 +0100

minexpert2 (8.6.2-2) unstable; urgency=low

  * Add Rules-Requires-Root to see if the dh_auto_test does not fail...

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 15 Dec 2022 10:57:51 +0100

minexpert2 (8.6.2-1) unstable; urgency=low

  * New upstream version with new libpappsomspp-dev dependency.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 14 Dec 2022 14:04:36 +0100

minexpert2 (8.6.1-1) unstable; urgency=low

  * Implemented loading of Bruker timsTOF data files with combination of all
    the mobility scans to a single spectrum for each frame.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 13 Dec 2022 18:42:56 +0100

minexpert2 (8.6.0-1) unstable; urgency=low

  * New upstream version now built against the Qt6 libraries.

  * Standards-Version: 4.6.1 (routine update)

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 Nov 2022 00:34:39 +0100

minexpert2 (8.5.3-1) unstable; urgency=low

  * New upstream release trying to fix the issue at
    https://gitlab.com/msxpertsuite/minexpert2/-/issues/6 pertaining
    to the color map data display in some Agilent files (thanks to Kevin


=== debian/control ===
Source: minexpert3
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 13),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 inkscape,
 libgomp1,
 qt6-base-dev,
 qt6-declarative-dev,
 libqt6svg6-dev,
 libqt6core5compat6-dev,
 libxkbcommon-x11-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
# Only the logically essential one.
 libpappsomspp-gui-dev (>= 0.11.0),
# Only the logically essential one.
 libxpertmassgui-dev (>= 1.3.0),
 libxpertmassgui-dev (>= 1.3.0),
 libisospec++-dev (>=2.2.1),
 libpwizlite-dev,
 libsqlite3-dev,
 libzstd-dev,
 liblzf-dev,
 zlib1g-dev,
 libquazip1-qt6-dev,
 libqcustomplot-dev (>= 2.1.0),
 libodsstream-dev (>= 0.9.14),
 libboost1.88-dev,
 libboost-thread1.88-dev,
 libboost-system1.88-dev,
 libboost-filesystem1.88-dev,
 libboost-iostreams1.88-dev,
 libboost-chrono1.88-dev,
 libboost-random1.88-dev,
 libboost-container1.88-dev,
 docbook-xml,
 docbook-to-man
Standards-Version: 4.7.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert3
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert3.git
Rules-Requires-Root: no

Package: minexpert2
Depends: minexpert3,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for minexpert2 -> minexpert3
 This is a transitional package. It can safely be removed.
 Runtime package.

Package: minexpert2-doc
Depends: minexpert3-doc,
         ${misc:Depends},
Architecture: all
Section: oldlibs
Description: transitional package for minexpert2-doc -> minexpert3-doc
 This is a transitional package. It can safely be removed.
 Documentation package.

Package: minexpert3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: minexpert3-doc (>= ${source:Upstream-Version})
Replaces: minexpert, minexpert2
Breaks: minexpert, minexpert
Description: MS^n mass spectrometric data visualization and mining (runtime)
 MineXpert3 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the MineXpert3 program.


Package: minexpert3-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: minexpert2-doc
Breaks: minexpert2-doc
Description: MS^n mass spectrometric data visualization and mining (doc)
 MineXpert3 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.
